;(function(){

	window._w.settings = {

		itemId        : null,
		itemData      : null,
		formMeta      : null,
		offerId       : null,
		offerData     : null,
		formOfferMeta : null,
		ti            : null,
		limited       : false,
		newItem       : false,

		onPageDestruct : function()
		{
			App.Event.removeListener('userGridSuFilter', 'SuChange');
			App.Event.removeListener('memberGridSuFilter', 'SuChange');
			App.Event.removeListener('clubGridSuFilter', 'SuChange');
			App.Event.removeListener('disputeGridSuFilter', 'SuChange');
      App.Event.removeListener('disputeGridDefSuFilter', 'SuChange');
			App.Event.removeListener('retailGridSuFilter', 'SuChange');
		},

		onViewTemplateReady : function( template, event, eventData )
		{
			_w.settings.ti = _t[template];

			_w.settings.initGrids();
			_w.settings.publishUserData();
			_w.settings.publishCompanyData();

		},

		onViewPublished : function( template, event, eventData )
		{
			$(".gridRetailFilter").keyup(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnRetailSearch').click();
				}
			});

			$(".gridQuestionFilter").keyup(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnQuestionSearch').click();
				}
			});

			$(".gridReplyFilter").keyup(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnReplySearch').click();
				}
			});

			$(".gridUserFilter").keyup(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnUserSearch').click();
				}
			});

			$(".gridMemberFilter").keyup(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnMemberSearch').click();
				}
			});

			$(".gridClubFilter").keyup(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnClubSearch').click();
				}
			});

			$(".gridDisputeFilter").keyup(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnDisputeSearch').click();
				}
			});
      
      $(".gridDisputeDefFilter").keyup(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnDisputeDefSearch').click();
				}
			});


			// Retail grid
			if (null == App.API.taskContract('gridRetail'))
			{
				App.API.getTask(
						'gridRetail', 'Company', 'CompanyRetail.Grid', null,
						{}, _w.settings.loadRetailGrid, _w.taskContractError
						);
			}
			else
			{
				_w.settings.loadRetailGrid( null, {}, {} );
			}

			// Question grid
			if (null == App.API.taskContract('gridQuestion'))
			{
				App.API.getTask(
						'gridQuestion', 'Auction', 'Question.AskedGrid', null,
						{}, _w.settings.loadQuestionGrid, _w.taskContractError
				);
			}
			else
			{
				_w.settings.loadQuestionGrid( null, {}, {} );
			}

			// Reply grid
			if (null == App.API.taskContract('gridReply'))
			{
				App.API.getTask(
						'gridReply', 'Auction', 'Question.ToAnswerGrid', null,
						{}, _w.settings.loadReplyGrid, _w.taskContractError
						);
			}
			else
			{
				_w.settings.loadReplyGrid( null, {}, {} );
			}

			// User grid
			if (null == App.API.taskContract('gridUser'))
			{
				App.API.getTask(
						'gridUser', 'User', 'Profile.Grid', null,
						{}, _w.settings.loadUserGrid, _w.taskContractError
						);
			}
			else
			{
				_w.settings.loadUserGrid( null, {}, {} );
			}

			// Membership Grid
			if (null == App.API.taskContract('gridMembership'))
			{
				App.API.getTask(
						'gridMembership', 'PriceGuide', 'Member.MembershipGrid', null,
						{}, _w.settings.loadMemberGrid, _w.taskContractError
				);
			}
			else
			{
				_w.settings.loadMemberGrid( null, {}, {} );
			}

			// Club Grid
			if (null == App.API.taskContract('gridClub'))
			{
				App.API.getTask(
						'gridClub', 'PriceGuide', 'Club.Grid', null,
						{}, _w.settings.loadClubGrid, _w.taskContractError
				);
			}
			else
			{
				_w.settings.loadClubGrid( null, {}, {} );
			}

			// Dispute grid
			if (null == App.API.taskContract('gridDispute'))
			{
				App.API.getTask(
						'gridDispute', 'Dispute', 'Dispute.Grid', null,
						{}, _w.settings.loadDisputeGrid, _w.taskContractError
						);
			}
			else
			{
				_w.settings.loadDisputeGrid( null, {}, {} );
			}
      
      // Dispute grid
			if (null == App.API.taskContract('gridDisputeDef'))
			{
				App.API.getTask(
						'gridDisputeDef', 'Dispute', 'Dispute.GridDef', null,
						{}, _w.settings.loadDisputeGridDef, _w.taskContractError
						);
			}
			else
			{
				_w.settings.loadDisputeGridDef( null, {}, {} );
			}

			// User and Company data display
			_w.settings.publishUserData();
			_w.settings.publishCompanyData();

			// Bindings
            if(true == App.permissions.settingsPersonal)
            {
            	$('#editPersonal').click(function() {
    				window.location.hash = '/userview?id=' + App.userData.id;
    			});
            }
            if(true == App.permissions.settingsDealership)
            {
            	$('#editCompany').click(function() {
    				window.location.hash = '/dealerview?id=' + App.companyData.id;
    			});
            }
            else
        	{
            	$('#editCompany').hide();
            }

			// Retail grid
			$('#btnRetailAdd').click(function() {
				window.location.hash = '/retailview?id=0';
			});
            $('#btnRetailClearSearch').click(_w.settings.clearRetailGridContext);
            $('#btnRetailSearch').click(_w.settings.searchRetailGrid);

            // Question grid
            $('#btnQuestionClearSearch').click(_w.settings.clearQuestionGridContext);
            $('#btnQuestionSearch').click(_w.settings.searchQuestionGrid);

			// Reply grid
            $('#btnReplyClearSearch').click(_w.settings.clearReplyGridContext);
            $('#btnReplySearch').click(_w.settings.searchReplyGrid);

			// User grid
			$('#btnUserAdd').click(function() {
				window.location.hash = '/userview?id=0';
			});
            $('#btnUserClearSearch').click(_w.settings.clearUserGridContext);
            $('#btnUserSearch').click(_w.settings.searchUserGrid);

			// Membership Grid
            $('#btnMemberClearSearch').click(_w.settings.clearMemberGridContext);
            $('#btnMemberSearch').click(_w.settings.searchMemberGrid);

			// Club Grid
			$('#btnClubAdd').click(function() {
				window.location.hash = '/clubview?id=0';
			});
            $('#btnClubClearSearch').click(_w.settings.clearClubGridContext);
            $('#btnClubSearch').click(_w.settings.searchClubGrid);

			// Dispute grid
            $('#btnDisputeClearSearch').click(_w.settings.clearDisputeGridContext);
            $('#btnDisputeSearch').click(_w.settings.searchDisputeGrid);
            
            // Dispute Def grid
            $('#btnDisputeDefClearSearch').click(_w.settings.clearDisputeGridDefContext);
            $('#btnDisputeDefSearch').click(_w.settings.searchDisputeGridDef);

            App.Event.listen('userGridSuFilter', 'SuChange', $.proxy(_w.settings.loadUserGrid, this), 'Recurring');
            App.Event.listen('memberGridSuFilter', 'SuChange', $.proxy(_w.settings.loadMemberGrid, this), 'Recurring');
            App.Event.listen('clubGridSuFilter', 'SuChange', $.proxy(_w.settings.loadClubGrid, this), 'Recurring');
            App.Event.listen('disputeGridSuFilter', 'SuChange', $.proxy(_w.settings.loadDisputeGrid, this), 'Recurring');
            App.Event.listen('disputeGridDefSuFilter', 'SuChange', $.proxy(_w.settings.loadDisputeGridDef, this), 'Recurring');
            App.Event.listen('retailGridSuFilter', 'SuChange', $.proxy(_w.settings.loadRetailGrid, this), 'Recurring');
		},

		initGrids : function()
		{

			_w.settings.ti.hydrate({
				// Retail grid
				'gridRetailTitle': 'Retail accounts',
				'gridRetailColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Name: {
							id: 'gridRetailColumn_Name',
							title: 'RETAILER',
							orderAsc: {
								id: 'gridRetailOrder_NameAsc',
								bind: $.proxy(_w.settings.orderRetailGrid, this, 'companyRetail.name', 'ASC')
							},
							orderDesc: {
								id: 'gridRetailOrder_NameDesc',
								bind: $.proxy(_w.settings.orderRetailGrid, this, 'companyRetail.name', 'DESC')
							}
						},
						Created: {
							id: 'gridRetailColumn_Created',
							title: 'CREATED',
							orderAsc: {
								id: 'gridRetailOrder_CreatedAsc',
								bind: $.proxy(_w.settings.orderRetailGrid, this, 'companyRetail.created', 'ASC')
							},
							orderDesc: {
								id: 'gridRetailOrder_CreatedDesc',
								bind: $.proxy(_w.settings.orderRetailGrid, this, 'companyRetail.create', 'DESC')
							}
						},
						Updated: {
							id: 'gridRetailColumn_Updated',
							title: 'UPDATED',
							orderAsc: {
								id: 'gridRetailOrder_UpdatedAsc',
								bind: $.proxy(_w.settings.orderRetailGrid, this, 'companyRetail.updated', 'ASC')
							},
							orderDesc: {
								id: 'gridRetailOrder_UpdatedDesc',
								bind: $.proxy(_w.settings.orderRetailGrid, this, 'companyRetail.updated', 'DESC')
							}
						},
						Status: {
							id: 'gridRetailColumn_Status',
							title: 'STATUS'
						}
					}
				},
				'gridRetailColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						Name: {
							id: 'gridRetailFilter_Name',
							context: 'gridRetailFilter'
						},
						Created: {
							id: 'gridRetailFilter_Created',
							context: 'gridRetailFilter'
						},
						Updated: {
							id: 'gridRetailFilter_Updated',
							context: 'gridRetailFilter'
						},
						Status : null
					}
				},
				'gridRetailRowRepeater': {},
				'gridRetailPager': {},

				// Question grid
				'gridQuestionTitle': 'Auction questions',
				'gridQuestionColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Created: {
							id: 'gridQuestionColumn_Created',
							title: 'CREATED',
							orderAsc: {
								id: 'gridQuestionOrder_CreatedAsc',
								bind: $.proxy(_w.settings.orderQuestionGrid, this, 'question.created', 'ASC')
							},
							orderDesc: {
								id: 'gridQuestionOrder_CreatedDesc',
								bind: $.proxy(_w.settings.orderQuestionGrid, this, 'question.create', 'DESC')
							}
						},
						Updated: {
							id: 'gridQuestionColumn_Updated',
							title: 'REPLIED',
							orderAsc: {
								id: 'gridQuestionOrder_UpdatedAsc',
								bind: $.proxy(_w.settings.orderQuestionGrid, this, 'question.updated', 'ASC')
							},
							orderDesc: {
								id: 'gridQuestionOrder_UpdatedDesc',
								bind: $.proxy(_w.settings.orderQuestionGrid, this, 'question.updated', 'DESC')
							}
						},
						Company: {
							id: 'gridQuestionColumn_Company',
							title: 'COMPANY',
							orderAsc: {
								id: 'gridQuestionOrder_CompanyAsc',
								bind: $.proxy(_w.settings.orderQuestionGrid, this, 'company.name', 'ASC')
							},
							orderDesc: {
								id: 'gridQuestionOrder_CompanyDesc',
								bind: $.proxy(_w.settings.orderQuestionGrid, this, 'company.name', 'DESC')
							}
						},
						Make: {
							id: 'gridQuestionColumn_Make',
							title: 'MAKE',
							orderAsc: {
								id: 'gridQuestionOrder_MakeAsc',
								bind: $.proxy(_w.auction.orderQuestionGrid, this, 'make.name', 'ASC')
							},
							orderDesc: {
								id: 'gridQuestionOrder_MakeDesc',
								bind: $.proxy(_w.auction.orderQuestionGrid, this, 'make.name', 'DESC')
							}
						},
						Model: {
							id: 'gridQuestionColumn_Model',
							title: 'MODEL',
							orderAsc: {
								id: 'gridQuestionOrder_ModelAsc',
								bind: $.proxy(_w.auction.orderQuestionGrid, this, 'model.name', 'ASC')
							},
							orderDesc: {
								id: 'gridQuestionOrder_ModelDesc',
								bind: $.proxy(_w.auction.orderQuestionGrid, this, 'model.name', 'DESC')
							}
						},
						Type: {
							id: 'gridQuestionColumn_Type',
							title: 'TYPE',
							orderAsc: {
								id: 'gridQuestionOrder_TypeAsc',
								bind: $.proxy(_w.auction.orderQuestionGrid, this, 'type.name', 'ASC')
							},
							orderDesc: {
								id: 'gridQuestionOrder_TypeDesc',
								bind: $.proxy(_w.auction.orderQuestionGrid, this, 'type.name', 'DESC')
							},
							style: 'type hidden-phone hidden-tablet'
						},
						Reg: {
							id: 'gridQuestionColumn_Reg',
							title: 'REGISTRATION',
							orderAsc: {
								id: 'gridQuestionOrder_RegAsc',
								bind: $.proxy(_w.auction.orderQuestionGrid, this, 'stock.registrationNumber', 'ASC')
							},
							orderDesc: {
								id: 'gridQuestionOrder_RegDesc',
								bind: $.proxy(_w.auction.orderQuestionGrid, this, 'stock.registrationNumber', 'DESC')
							},
							style: 'year'
						}
					}
				},
				'gridQuestionColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						Created: {
							id: 'gridQuestionFilter_Created',
							context: 'gridQuestionFilter'
						},
						Updated: {
							id: 'gridQuestionFilter_Updated',
							context: 'gridQuestionFilter'
						},
						Company: {
							id: 'gridQuestionFilter_Company',
							context: 'gridQuestionFilter'
						},
						Make: {
							id: 'gridQuestionFilter_Make',
							context: 'gridQuestionFilter'
						},
						Model: {
							id: 'gridQuestionFilter_Model',
							context: 'gridQuestionFilter'
						},
						Type: {
							id: 'gridQuestionFilter_Type',
							context: 'gridQuestionFilter'
						},
						Reg: {
							id: 'gridQuestionFilter_Reg',
							context: 'gridQuestionFilter'
						}
					}
				},
				'gridQuestionRowRepeater': {},
				'gridQuestionPager': {},

				// Reply grid
				'gridReplyTitle': 'Questions awaiting your reply',
				'gridReplyColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Created: {
							id: 'gridReplyColumn_Created',
							title: 'CREATED',
							orderAsc: {
								id: 'gridReplyOrder_CreatedAsc',
								bind: $.proxy(_w.settings.orderReplyGrid, this, 'question.created', 'ASC')
							},
							orderDesc: {
								id: 'gridReplyOrder_CreatedDesc',
								bind: $.proxy(_w.settings.orderReplyGrid, this, 'question.create', 'DESC')
							}
						},
						Updated: {
							id: 'gridReplyColumn_Updated',
							title: 'REPLIED',
							orderAsc: {
								id: 'gridReplyOrder_UpdatedAsc',
								bind: $.proxy(_w.settings.orderReplyGrid, this, 'question.updated', 'ASC')
							},
							orderDesc: {
								id: 'gridReplyOrder_UpdatedDesc',
								bind: $.proxy(_w.settings.orderReplyGrid, this, 'question.updated', 'DESC')
							}
						},
						Company: {
							id: 'gridReplyColumn_Company',
							title: 'COMPANY',
							orderAsc: {
								id: 'gridReplyOrder_CompanyAsc',
								bind: $.proxy(_w.settings.orderReplyGrid, this, 'company.name', 'ASC')
							},
							orderDesc: {
								id: 'gridReplyOrder_CompanyDesc',
								bind: $.proxy(_w.settings.orderReplyGrid, this, 'company.name', 'DESC')
							}
						},
						Make: {
							id: 'gridReplyColumn_Make',
							title: 'MAKE',
							orderAsc: {
								id: 'gridReplyOrder_MakeAsc',
								bind: $.proxy(_w.auction.orderReplyGrid, this, 'make.name', 'ASC')
							},
							orderDesc: {
								id: 'gridReplyOrder_MakeDesc',
								bind: $.proxy(_w.auction.orderReplyGrid, this, 'make.name', 'DESC')
							}
						},
						Model: {
							id: 'gridReplyColumn_Model',
							title: 'MODEL',
							orderAsc: {
								id: 'gridReplyOrder_ModelAsc',
								bind: $.proxy(_w.auction.orderReplyGrid, this, 'model.name', 'ASC')
							},
							orderDesc: {
								id: 'gridReplyOrder_ModelDesc',
								bind: $.proxy(_w.auction.orderReplyGrid, this, 'model.name', 'DESC')
							}
						},
						Type: {
							id: 'gridReplyColumn_Type',
							title: 'TYPE',
							orderAsc: {
								id: 'gridReplyOrder_TypeAsc',
								bind: $.proxy(_w.auction.orderReplyGrid, this, 'type.name', 'ASC')
							},
							orderDesc: {
								id: 'gridReplyOrder_TypeDesc',
								bind: $.proxy(_w.auction.orderReplyGrid, this, 'type.name', 'DESC')
							},
							style: 'type hidden-phone hidden-tablet'
						},
						Reg: {
							id: 'gridReplyColumn_Reg',
							title: 'REGISTRATION',
							orderAsc: {
								id: 'gridReplyOrder_RegAsc',
								bind: $.proxy(_w.auction.orderReplyGrid, this, 'stock.registrationNumber', 'ASC')
							},
							orderDesc: {
								id: 'gridReplyOrder_RegDesc',
								bind: $.proxy(_w.auction.orderReplyGrid, this, 'stock.registrationNumber', 'DESC')
							},
							style: 'year'
						}
					}
				},
				'gridReplyColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						Created: {
							id: 'gridReplyFilter_Created',
							context: 'gridReplyFilter'
						},
						Updated: {
							id: 'gridReplyFilter_Updated',
							context: 'gridReplyFilter'
						},
						Company: {
							id: 'gridReplyFilter_Company',
							context: 'gridReplyFilter'
						},
						Make: {
							id: 'gridReplyFilter_Make',
							context: 'gridReplyFilter'
						},
						Model: {
							id: 'gridReplyFilter_Model',
							context: 'gridReplyFilter'
						},
						Type: {
							id: 'gridReplyFilter_Type',
							context: 'gridReplyFilter'
						},
						Reg: {
							id: 'gridReplyFilter_Reg',
							context: 'gridReplyFilter'
						}
					}
				},
				'gridReplyRowRepeater': {},
				'gridReplyPager': {},

				// User grid
				'gridUserTitle': 'Manage my users',
				'gridUserColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Name: {
							id: 'gridUserColumn_Name',
							title: 'NAME',
							orderAsc: {
								id: 'gridUserOrder_FirstNameAsc',
								bind: $.proxy(_w.settings.orderUserGrid, this, 'profile.firstName', 'ASC')
							},
							orderDesc: {
								id: 'gridUserOrder_VinDesc',
								bind: $.proxy(_w.settings.orderUserGrid, this, 'profile.firstName', 'DESC')
							}
						},
						Surname: {
							id: 'gridUserColumn_Surname',
							title: 'SURNAME',
							orderAsc: {
								id: 'gridUserOrder_SurnameAsc',
								bind: $.proxy(_w.settings.orderUserGrid, this, 'profile.familyName', 'ASC')
							},
							orderDesc: {
								id: 'gridUserOrder_SurnameDesc',
								bind: $.proxy(_w.settings.orderUserGrid, this, 'profile.familyName', 'DESC')
							}
						},
						Email: {
							id: 'gridUserColumn_Email',
							title: 'EMAIL',
							orderAsc: {
								id: 'gridUserOrder_EmailAsc',
								bind: $.proxy(_w.settings.orderUserGrid, this, 'profile.email', 'ASC')
							},
							orderDesc: {
								id: 'gridUserOrder_EmailDesc',
								bind: $.proxy(_w.settings.orderUserGrid, this, 'profile.email', 'DESC')
							}
						},
						Mobile: {
							id: 'gridUserColumn_Mobile',
							title: 'MOBILE',
							orderAsc: {
								id: 'gridUserOrder_MobileAsc',
								bind: $.proxy(_w.settings.orderUserGrid, this, 'profile.mobile', 'ASC')
							},
							orderDesc: {
								id: 'gridUserOrder_MobileDesc',
								bind: $.proxy(_w.settings.orderUserGrid, this, 'profile.mobile', 'DESC')
							},
							style: 'hidden-phone hidden-tablet'
						},
						UserType: {
							id: 'gridUserColumn_UserType',
							title: 'USER TYPE',
							orderAsc: {
								id: 'gridUserOrder_UserTypeAsc',
								bind: $.proxy(_w.settings.orderUserGrid, this, 'permissions.name', 'ASC')
							},
							orderDesc: {
								id: 'gridUserOrder_UserTypeDesc',
								bind: $.proxy(_w.settings.orderUserGrid, this, 'permissions.name', 'DESC')
							}
						},
						AssignedTo: {
							id: 'gridUserColumn_AssignedTo',
							title: 'ASSIGNED TO',
							orderAsc: {
								id: 'gridUserOrder_AssignedToAsc',
								bind: $.proxy(_w.settings.orderUserGrid, this, 'manager.firstName', 'ASC')
							},
							orderDesc: {
								id: 'AssignedToDesc',
								bind: $.proxy(_w.settings.orderUserGrid, this, 'manager.firstName', 'DESC')
							},
							style: 'hidden-phone hidden-tablet'
						}
					}
				},
				'gridUserColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						Name: {
							id: 'gridUserFilter_Name',
							context: 'gridUserFilter'
						},
						Surname: {
							id: 'gridUserFilter_Surname',
							context: 'gridUserFilter'
						},
						Email: {
							id: 'gridUserFilter_Email',
							context: 'gridUserFilter'
						},
						Mobile: {
							id: 'gridUserFilter_Mobile',
							context: 'gridUserFilter'
						},
						UserType: {
							id: 'gridUserFilter_UserType',
							context: 'gridUserFilter'
						},
						AssignedTo: {
							id: 'gridUserFilter_AssignedTo',
							context: 'gridUserFilter'
						}
					}
				},
				'gridUserRowRepeater': {},
				'gridUserPager': {},

				// Club membership grid
				'gridMemberTitle': 'My club membership',
				'gridMemberColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Name: {
							id: 'gridMemberColumn_Name',
							title: 'NAME',
							orderAsc: {
								id: 'gridMemberOrder_NameAsc',
								bind: $.proxy(_w.settings.orderMemberGrid, this, 'club.name', 'ASC')
							},
							orderDesc: {
								id: 'gridMemberOrder_NameDesc',
								bind: $.proxy(_w.settings.orderMemberGrid, this, 'club.name', 'DESC')
							}
						},
						Sms: {
							id: 'gridMemberColumn_Sms',
							title: 'SMS',
							orderAsc: {
								id: 'gridMemberOrder_SMSAsc',
								bind: $.proxy(_w.settings.orderMemberGrid, this, 'mmbr.smsNotification', 'ASC')
							},
							orderDesc: {
								id: 'gridMemberOrder_SMSDesc',
								bind: $.proxy(_w.settings.orderMemberGrid, this, 'mmbr.smsNotification', 'DESC')
							}
						},
						Email: {
							id: 'gridMemberColumn_Email',
							title: 'EMAIL',
							orderAsc: {
								id: 'gridMemberOrder_EmailAsc',
								bind: $.proxy(_w.settings.orderMemberGrid, this, 'mmbr.emailNotification', 'ASC')
							},
							orderDesc: {
								id: 'gridMemberOrder_EmailDesc',
								bind: $.proxy(_w.settings.orderMemberGrid, this, 'mmbr.emailNotification', 'DESC')
							}
						},
						AllMakes: {
							id: 'gridMemberColumn_AllMakes',
							title: 'ALL MAKES',
							orderAsc: {
								id: 'gridMemberOrder_AllMakesAsc',
								bind: $.proxy(_w.settings.orderMemberGrid, this, 'mmbr.allMakes', 'ASC')
							},
							orderDesc: {
								id: 'gridMemberOrder_AllMakesDesc',
								bind: $.proxy(_w.settings.orderMemberGrid, this, 'mmbr.allMakes', 'DESC')
							}
						},
						Status: {
							id: 'gridMemberColumn_Status',
							title: 'STATUS',
							orderAsc: {
								id: 'gridMemberOrder_StatusAsc',
								bind: $.proxy(_w.settings.orderMemberGrid, this, 'mmbr.status', 'ASC')
							},
							orderDesc: {
								id: 'gridMemberOrder_StatusDesc',
								bind: $.proxy(_w.settings.orderMemberGrid, this, 'mmbr.status', 'DESC')
							}
						}
					}
				},
				'gridMemberColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						Name: {
							id: 'gridMemberFilter_Name',
							context: 'gridMemberFilter'
						},
						Sms: null,
						Email: null,
						AllMakes: null,
						Status: {
							id: 'gridMemberFilter_Status',
							context: 'gridMemberFilter'
						}
					}
				},
				'gridMemberRowRepeater': {},
				'gridMemberPager': {},

				// Club grid
				'gridClubTitle': 'My clubs',
				'gridClubColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Name: {
							id: 'gridClubColumn_Name',
							title: 'NAME',
							orderAsc: {
								id: 'gridClubOrder_NameAsc',
								bind: $.proxy(_w.settings.orderClubGrid, this, 'club.name', 'ASC')
							},
							orderDesc: {
								id: 'gridClubOrder_NameDesc',
								bind: $.proxy(_w.settings.orderClubGrid, this, 'club.name', 'DESC')
							}
						},
						UseAsDefault: {
							id: 'gridClubColumn_UseAsDefault',
							title: 'DEFAULT',
							orderAsc: {
								id: 'gridClubOrder_UseAsDefaultAsc',
								bind: $.proxy(_w.settings.orderClubGrid, this, 'club.useAsDefault', 'ASC')
							},
							orderDesc: {
								id: 'gridClubOrder_UseAsDefaultDesc',
								bind: $.proxy(_w.settings.orderClubGrid, this, 'club.useAsDefault', 'DESC')
							}
						},
						Created: {
							id: 'gridClubColumn_Created',
							title: 'CREATED',
							orderAsc: {
								id: 'gridClubOrder_CreatedAsc',
								bind: $.proxy(_w.settings.orderClubGrid, this, 'club.created', 'ASC')
							},
							orderDesc: {
								id: 'gridClubOrder_CreatedDesc',
								bind: $.proxy(_w.settings.orderClubGrid, this, 'club.created', 'DESC')
							}
						},
						Members: {
							id: 'gridClubColumn_Members',
							title: 'MEMBERS',
							orderAsc: {
								id: 'gridClubOrder_MembersAsc',
								bind: $.proxy(_w.settings.orderClubGrid, this, 'numMembers', 'ASC')
							},
							orderDesc: {
								id: 'gridClubOrder_MembersDesc',
								bind: $.proxy(_w.settings.orderClubGrid, this, 'numMembers', 'DESC')
							}
						}
					}
				},
				'gridClubColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						Name: {
							id: 'gridClubFilter_Name',
							context: 'gridClubFilter'
						},
						UseAsDefault: null,
						Created: null,
						Members: null
					}
				},
				'gridClubRowRepeater': {},
				'gridClubPager': {},

				// Dispute grid
				'gridDisputeTitle': 'Disputes (Plaintif)',
				'gridDisputeColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Plaintive: {
							id: 'gridDisputeColumn_Defendant',
							title: 'DEFENDANT',
							orderAsc: {
								id: 'gridDisputeOrder_DefendantAsc',
								bind: $.proxy(_w.settings.orderDisputeGrid, this, 'againstCompany.name', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeOrder_DefendantDesc',
								bind: $.proxy(_w.settings.orderDisputeGrid, this, 'againstCompany.name', 'DESC')
							}
						},
						Make: {
							id: 'gridDisputeColumn_Make',
							title: 'VEHICLE MAKE',
							orderAsc: {
								id: 'gridDisputeOrder_MakeAsc',
								bind: $.proxy(_w.settings.orderDisputeGrid, this, 'make.name', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeOrder_MakeDesc',
								bind: $.proxy(_w.settings.orderDisputeGrid, this, 'make.name', 'DESC')
							}
						},
						Model: {
							id: 'gridDisputeColumn_Model',
							title: 'MODEL',
							orderAsc: {
								id: 'gridDisputeOrder_ModelAsc',
								bind: $.proxy(_w.settings.orderDisputeGrid, this, 'model.name', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeOrder_ModelDesc',
								bind: $.proxy(_w.settings.orderDisputeGrid, this, 'model.name', 'DESC')
							}
						},
						Type: {
							id: 'gridDisputeColumn_Type',
							title: 'TYPE',
							orderAsc: {
								id: 'gridDisputeOrder_TypeAsc',
								bind: $.proxy(_w.settings.orderDisputeGrid, this, 'type.name', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeOrder_TypeDesc',
								bind: $.proxy(_w.settings.orderDisputeGrid, this, 'type.name', 'DESC')
							},
							style: 'hidden-phone hidden-tablet'
						},
						Reg: {
							id: 'gridDisputeColumn_Reg',
							title: 'REGISTRATION',
							orderAsc: {
								id: 'gridDisputeOrder_RegAsc',
								bind: $.proxy(_w.settings.orderDisputeGrid, this, 'stock.registrationNumber', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeOrder_RegDesc',
								bind: $.proxy(_w.settings.orderDisputeGrid, this, 'stock.registrationNumber', 'DESC')
							}
						},
						Status: {
							id: 'gridDisputeColumn_Status',
							title: 'STATUS',
							orderAsc: {
								id: 'gridDisputeOrder_StatusAsc',
								bind: $.proxy(_w.settings.orderDisputeGrid, this, 'dispute.jobState', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeOrder_StatusDesc',
								bind: $.proxy(_w.settings.orderDisputeGrid, this, 'dispute.jobState', 'DESC')
							}
						}
					}
				},
				'gridDisputeColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						Plaintive: {
							id: 'gridDisputeFilter_Defendant',
							context: 'gridDisputeFilter'
						},
						Make: {
							id: 'gridDisputeFilter_Make',
							context: 'gridDisputeFilter'
						},
						Model: {
							id: 'gridDisputeFilter_Model',
							context: 'gridDisputeFilter'
						},
						Type: {
							id: 'gridDisputeFilter_Type',
							context: 'gridDisputeFilter'
						},
						Reg: {
							id: 'gridDisputeFilter_Reg',
							context: 'gridDisputeFilter'
						},
						Status: {
							id: 'gridDisputeFilter_Status',
							context: 'gridDisputeFilter'
						}
					}
				},
				'gridDisputeRowRepeater': {},
				'gridDisputePager': {},
        
        // Dispute Defendant grid
				'gridDisputeDefTitle': 'Disputes (Defendant)',
				'gridDisputeDefColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Plaintive: {
							id: 'gridDisputeDefColumn_Plaintive',
							title: 'PLAINTIFF',
							orderAsc: {
								id: 'gridDisputeDefOrder_PlaintiveAsc',
								bind: $.proxy(_w.settings.orderDisputeGridDef, this, 'fromCompany.name', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeDefOrder_PlaintiveDesc',
								bind: $.proxy(_w.settings.orderDisputeGridDef, this, 'fromCompany.name', 'DESC')
							}
						},
						Make: {
							id: 'gridDisputeDefColumn_Make',
							title: 'VEHICLE MAKE',
							orderAsc: {
								id: 'gridDisputeDefOrder_MakeAsc',
								bind: $.proxy(_w.settings.orderDisputeGridDef, this, 'make.name', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeDefOrder_MakeDesc',
								bind: $.proxy(_w.settings.orderDisputeGridDef, this, 'make.name', 'DESC')
							}
						},
						Model: {
							id: 'gridDisputeDefColumn_Model',
							title: 'MODEL',
							orderAsc: {
								id: 'gridDisputeDefOrder_ModelAsc',
								bind: $.proxy(_w.settings.orderDisputeGridDef, this, 'model.name', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeDefOrder_ModelDesc',
								bind: $.proxy(_w.settings.orderDisputeGridDef, this, 'model.name', 'DESC')
							}
						},
						Type: {
							id: 'gridDisputeDefColumn_Type',
							title: 'TYPE',
							orderAsc: {
								id: 'gridDisputeDefOrder_TypeAsc',
								bind: $.proxy(_w.settings.orderDisputeGridDef, this, 'type.name', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeDefOrder_TypeDesc',
								bind: $.proxy(_w.settings.orderDisputeGridDef, this, 'type.name', 'DESC')
							},
							style: 'hidden-phone hidden-tablet'
						},
						Reg: {
							id: 'gridDisputeDefColumn_Reg',
							title: 'REGISTRATION',
							orderAsc: {
								id: 'gridDisputeDefOrder_RegAsc',
								bind: $.proxy(_w.settings.orderDisputeGridDef, this, 'stock.registrationNumber', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeDefOrder_RegDesc',
								bind: $.proxy(_w.settings.orderDisputeGridDef, this, 'stock.registrationNumber', 'DESC')
							}
						},
						Status: {
							id: 'gridDisputeDefColumn_Status',
							title: 'STATUS',
							orderAsc: {
								id: 'gridDisputeDefOrder_StatusAsc',
								bind: $.proxy(_w.settings.orderDisputeGridDef, this, 'dispute.jobState', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeDefOrder_StatusDesc',
								bind: $.proxy(_w.settings.orderDisputeGridDef, this, 'dispute.jobState', 'DESC')
							}
						}
					}
				},
				'gridDisputeDefColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						Plaintive: {
							id: 'gridDisputeDefFilter_Plaintive',
							context: 'gridDisputeDefFilter'
						},
						Make: {
							id: 'gridDisputeDefFilter_Make',
							context: 'gridDisputeDefFilter'
						},
						Model: {
							id: 'gridDisputeDefFilter_Model',
							context: 'gridDisputeDefFilter'
						},
						Type: {
							id: 'gridDisputeDefFilter_Type',
							context: 'gridDisputeDefFilter'
						},
						Reg: {
							id: 'gridDisputeDefFilter_Reg',
							context: 'gridDisputeDefFilter'
						},
						Status: {
							id: 'gridDisputeDefFilter_Status',
							context: 'gridDisputeDefFilter'
						}
					}
				},
				'gridDisputeDefRowRepeater': {},
				'gridDisputeDefPager': {}
			});
		},

		loadRetailGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridRetail', data, options,
					_w.settings._onRetailGridDataReceived, _w.taskExecError
					);
		},

		pageRetailGrid : function( page )
		{
			_w.settings.loadRetailGrid( {}, {"Grid":{"Page":page}} );
		},

		clearRetailGridContext : function()
		{
			$('.gridRetailContext').val('');
			$('.gridRetailFilter').val('');
			_w.settings.searchRetailGrid();
		},

		searchRetailGrid : function()
		{
			var filter = {
					count: 0,
					filters: {}
			};

			filter = _w.filterIfnotEmpty(filter, 'gridRetailFilter_Name', 'companyRetail.name');
			filter = _w.filterIfnotEmpty(filter, 'gridRetailFilter_Created', 'companyRetail.created');
			filter = _w.filterIfnotEmpty(filter, 'gridRetailFilter_Updated', 'companyRetail.updated');
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			_w.settings.loadRetailGrid( null, request, {} );
		},

		_onRetailGridDataReceived : function( response )
		{
			_w.settings.ti.hydrateParam('gridRetailRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'companyRetail.name'            : 'gridRetailFilter_Name',
				'companyRetail.created'         : 'gridRetailFilter_Created',
				'companyRetail.updated'         : 'gridRetailFilter_Updated'
			});
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				gridData.push({
					url: 'retailview',
					prepend: {},
					style: {},
					items: {
						'id'      : row.id,
						'Name'    : row.name,
						'Created' : ((row.created).split(' '))[0],
						'Updated' : row.updated ? ((row.updated).split(' '))[0] : '',
						'Status'  : row.archived ? 'Archived' : 'Active'
				}
				});
			}
			_w.settings.ti.hydrateParam('gridRetailRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'retailPager';
			response.Data.Meta.bind = _w.settings.pageRetailGrid;
			_w.settings.ti.hydrateParam('gridRetailPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});

			true == App.permissions.settingsRetail ? $('#retailGrid').show() : $('#retailGrid').hide();
		},

		loadQuestionGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridQuestion', data, options,
					_w.settings._onQuestionGridDataReceived, _w.taskExecError
					);
		},

		pageQuestionGrid : function( page )
		{
			_w.settings.loadQuestionGrid( {}, {"Grid":{"Page":page}} );
		},

		clearQuestionGridContext : function()
		{
			$('.gridQuestionContext').val('');
			$('.gridQuestionFilter').val('');
			_w.settings.searchQuestionGrid();
		},

		searchQuestionGrid : function()
		{
			var filter = {
					count: 0,
					filters: {}
			};

			filter = _w.filterIfnotEmpty(filter, 'gridQuestionFilter_Created', 'question.created');
			filter = _w.filterIfnotEmpty(filter, 'gridQuestionFilter_Updated', 'question.updated');
			filter = _w.filterIfnotEmpty(filter, 'gridQuestionFilter_Company', 'company.name');
			filter = _w.filterIfnotEmpty(filter, 'gridQuestionFilter_Make', 'make.name');
			filter = _w.filterIfnotEmpty(filter, 'gridQuestionFilter_Model', 'model.name');
			filter = _w.filterIfnotEmpty(filter, 'gridQuestionFilter_Type', 'type.name');
			filter = _w.filterIfnotEmpty(filter, 'gridQuestionFilter_Reg', 'stock.registrationNumber');
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			_w.settings.loadQuestionGrid( null, request, {} );
		},

		_onQuestionGridDataReceived : function( response )
		{
			_w.settings.ti.hydrateParam('gridQuestionRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'question.created'         : 'gridQuestionFilter_Created',
				'question.updated'         : 'gridQuestionFilter_Updated',
				'company.name'             : 'gridQuestionFilter_Company',
				'make.name'                : 'gridQuestionFilter_Make',
				'model.name'               : 'gridQuestionFilter_Model',
				'type.name'                : 'gridQuestionFilter_Type',
				'stock.registrationNumber' : 'gridQuestionFilter_Reg'
			});
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				gridData.push({
					url: 'questionview',
					prepend: {},
					style: {
						Type   	: 'type hidden-phone hidden-tablet',
					},
					items: {
						'id'      : {id: row.id, auctionId: row.auction.id},
						'Created' : ((row.created).split(' '))[0],
						'Updated' : row.updated ? ((row.updated).split(' '))[0] : '',
						'Company' : row.auction.company.name,
						'Make'    : row.auction.stock.type.model.make.name,
						'Model'   : row.auction.stock.type.model.name,
						'Type'    : row.auction.stock.type.name,
						'Reg'     : row.auction.stock.registrationNumber
				}
				});
			}
			_w.settings.ti.hydrateParam('gridQuestionRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'questionPager';
			response.Data.Meta.bind = _w.settings.pageQuestionGrid;
			_w.settings.ti.hydrateParam('gridQuestionPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});

			true == App.permissions.auctionPage ? $('#questionsGrid').show() : $('#questionsGrid').hide();
		},

		loadReplyGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridReply', data, options,
					_w.settings._onReplyGridDataReceived, _w.taskExecError
					);
		},

		pageReplyGrid : function( page )
		{
			_w.settings.loadReplyGrid( {}, {"Grid":{"Page":page}} );
		},

		clearReplyGridContext : function()
		{
			$('.gridReplyContext').val('');
			$('.gridReplyFilter').val('');
			_w.settings.searchReplyGrid();
		},

		searchReplyGrid : function()
		{
			var filter = {
					count: 0,
					filters: {}
			};

			filter = _w.filterIfnotEmpty(filter, 'gridReplyFilter_Created', 'question.created');
			filter = _w.filterIfnotEmpty(filter, 'gridReplyFilter_Updated', 'question.updated');
			filter = _w.filterIfnotEmpty(filter, 'gridReplyFilter_Company', 'company.name');
			filter = _w.filterIfnotEmpty(filter, 'gridReplyFilter_Make', 'make.name');
			filter = _w.filterIfnotEmpty(filter, 'gridReplyFilter_Model', 'model.name');
			filter = _w.filterIfnotEmpty(filter, 'gridReplyFilter_Type', 'type.name');
			filter = _w.filterIfnotEmpty(filter, 'gridReplyFilter_Reg', 'stock.registrationNumber')
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			_w.settings.loadReplyGrid( null, request, {} );
		},

		_onReplyGridDataReceived : function( response )
		{
			_w.settings.ti.hydrateParam('gridReplyRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'question.created'         : 'gridReplyFilter_Created',
				'question.updated'         : 'gridReplyFilter_Updated',
				'company.name'             : 'gridReplyFilter_Company',
				'make.name'                : 'gridReplyFilter_Make',
				'model.name'               : 'gridReplyFilter_Model',
				'type.name'                : 'gridReplyFilter_Type',
				'stock.registrationNumber' : 'gridReplyFilter_Reg'
			});
			var gridData = [];
			console.log(response.Data.DataSet);
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				gridData.push({
					url: 'replyview',
					prepend: {},
					style: {
						Type   	: 'type hidden-phone hidden-tablet',
					},
					items: {
						'id'      : {id: row.id, auctionId: row.auction.id},
						'Created' : ((row.created).split(' '))[0],
						'Updated' : row.updated ? ((row.updated).split(' '))[0] : '',
						'Company' : row.company.name,
						'Make'    : row.auction.stock.type.model.make.name,
						'Model'   : row.auction.stock.type.model.name,
						'Type'    : row.auction.stock.type.name,
						'Reg'     : row.auction.stock.registrationNumber
				}
				});
			}
			_w.settings.ti.hydrateParam('gridReplyRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'userPager';
			response.Data.Meta.bind = _w.settings.pageReplyGrid;
			_w.settings.ti.hydrateParam('gridReplyPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});

			true == App.permissions.auctionPage ? $('#replyGrid').show() : $('#replyGrid').hide();
		},

		loadUserGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridUser', data, options,
					_w.settings._onUserGridDataReceived, _w.taskExecError
					);
		},

		pageUserGrid : function( page )
		{
			_w.settings.loadUserGrid( {}, {"Grid":{"Page":page}} );
		},

		clearUserGridContext : function()
		{
			$('.gridUserContext').val('');
			$('.gridUserFilter').val('');
			_w.settings.searchUserGrid();
		},

		searchUserGrid : function()
		{
			var filter = {
					count: 0,
					filters: {}
			};

			filter = _w.filterIfnotEmpty(filter, 'gridUserFilter_Name', 'profile.firstName');
			filter = _w.filterIfnotEmpty(filter, 'gridUserFilter_Surname', 'profile.familyName');
			filter = _w.filterIfnotEmpty(filter, 'gridUserFilter_Email', 'profile.email');
			filter = _w.filterIfnotEmpty(filter, 'gridUserFilter_Mobile', 'profile.mobile');
			filter = _w.filterIfnotEmpty(filter, 'gridUserFilter_UserType', 'permissions.name');
			filter = _w.filterIfnotEmpty(filter, 'gridUserFilter_AssignedTo', 'manager.firstName');
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			_w.settings.loadUserGrid( null, request, {} );
		},

		_onUserGridDataReceived : function( response )
		{
			_w.settings.ti.hydrateParam('gridUserRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'profile.firstName'  : 'gridUserFilter_Name',
				'profile.familyName' : 'gridUserFilter_Surname',
				'profile.email'      : 'gridUserFilter_Email',
				'profile.mobile'     : 'gridUserFilter_Mobile',
				'permissions.name'   : 'gridUserFilter_UserType',
				'manager.firstName'  : 'gridUserFilter_AssignedTo'
			});
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				gridData.push({
					url: 'userview',
					prepend: {},
					style: {
						Mobile   	: 'type hidden-phone hidden-tablet',
						AssignedTo   	: 'type hidden-phone hidden-tablet'
					},
					items: {
						'id'         : row.id,
						'Name'       : row.firstName,
						'Surname'    : row.familyName,
						'Email'      : row.email,
						'Mobile'     : row.mobile,
						'UserType'   : row.permissions ? row.permissions.name : '',
						'AssignedTo' : row.manager ? row.manager.firstName : ''
				}
				});
			}
			_w.settings.ti.hydrateParam('gridUserRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'userPager';
			response.Data.Meta.bind = _w.settings.pageUserGrid;
			_w.settings.ti.hydrateParam('gridUserPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});

			true == App.permissions.settingsUser ? $('#usersGrid').show() : $('#usersGrid').hide();
			true == App.permissions.settingsClub ? $('#clubsGrid').show() : $('#clubsGrid').hide();
		},

		loadMemberGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridMembership', data, options,
					_w.settings._onMemberGridDataReceived, _w.taskExecError
					);
		},

		pageMemberGrid : function( page )
		{
			_w.settings.loadMemberGrid( {}, {"Grid":{"Page":page}} );
		},

		clearMemberGridContext : function()
		{
			$('.gridMemberContext').val('');
			$('.gridMemberFilter').val('');
			_w.settings.searchMemberGrid();
		},

		searchMemberGrid : function()
		{
			var filter = {
					count: 0,
					filters: {}
			};
			filter = _w.filterIfnotEmpty(filter, 'gridMemberFilter_Name', 'club.name');
			filter = _w.filterIfnotEmpty(filter, 'gridMemberFilter_Status', 'mmbr.status');
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			_w.settings.loadMemberGrid( null, request, {} );
		},

		_onMemberGridDataReceived : function( response )
		{
			_w.settings.ti.hydrateParam('gridMemberRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'club.name'   : 'gridMemberFilter_Name',
				'mmbr.status' : 'gridMemberFilter_Status'
			});
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				gridData.push({
					url: 'membershipview',
					prepend: {},
					style: {},
					items: {
						'id'       : row.id,
						'Name'     : row.club.name,
						'Sms'      : row.smsNotification ? 'Yes' : 'No',
						'Email'    : row.emailNotification ? 'Yes' : 'No',
						'AllMakes' : row.allMakes ? 'Yes' : 'No',
						'Status'   : row.status
				}
				});
			}
			_w.settings.ti.hydrateParam('gridMemberRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'memberPager';
			response.Data.Meta.bind = _w.settings.pageMemberGrid;
			_w.settings.ti.hydrateParam('gridMemberPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});
		},



		loadClubGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridClub', data, options,
					_w.settings._onClubGridDataReceived, _w.taskExecError
					);
		},

		pageClubGrid : function( page )
		{
			_w.settings.loadClubGrid( {}, {"Grid":{"Page":page}} );
		},

		clearClubGridContext : function()
		{
			$('.gridClubContext').val('');
			$('.gridClubFilter').val('');
			_w.settings.searchClubGrid();
		},

		searchClubGrid : function()
		{
			var filter = {
					count: 0,
					filters: {}
			};
			filter = _w.filterIfnotEmpty(filter, 'gridClubFilter_Name', 'club.name');
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			_w.settings.loadClubGrid( null, request, {} );
		},

		_onClubGridDataReceived : function( response )
		{
			_w.settings.ti.hydrateParam('gridClubRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'club.name'   : 'gridClubFilter_Name'
			});
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				gridData.push({
					url: 'clubview',
					prepend: {},
					style: {},
					items: {
						'id'           : row.id,
						'Name'         : row.name,
						'UseAsDefault' : row.useAsDefault ? 'Yes' : 'No',
						'Created'      : row.created,
						'Members'      : row.numMembers
				}
				});
			}
			_w.settings.ti.hydrateParam('gridClubRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'clubPager';
			response.Data.Meta.bind = _w.settings.pageClubGrid;
			_w.settings.ti.hydrateParam('gridClubPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});
		},

		loadDisputeGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridDispute', data, options,
					_w.settings._onDisputeGridDataReceived, _w.taskExecError
					);
		},

		pageDisputeGrid : function( page )
		{
			_w.settings.loadDisputeGrid( {}, {"Grid":{"Page":page}} );
		},

		clearDisputeGridContext : function()
		{
			$('.gridDisputeContext').val('');
			$('.gridDisputeFilter').val('');
			_w.settings.searchDisputeGrid();
		},

		searchDisputeGrid : function()
		{
			var filter = {
					count: 0,
					filters: {}
			};

			filter = _w.filterIfnotEmpty(filter, 'gridDisputeFilter_Defendant', 'againstCompany.name');
			filter = _w.filterIfnotEmpty(filter, 'gridDisputeFilter_Make', 'make.name');
			filter = _w.filterIfnotEmpty(filter, 'gridDisputeFilter_Model', 'model.name');
			filter = _w.filterIfnotEmpty(filter, 'gridDisputeFilter_Type', 'type.name');
			filter = _w.filterIfnotEmpty(filter, 'gridDisputeFilter_Reg', 'stock.registrationNumber');
			filter = _w.filterIfnotEmpty(filter, 'gridDisputeFilter_Status', 'dispute.jobState');
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			_w.settings.loadDisputeGrid( null, request, {} );
		},

		_onDisputeGridDataReceived : function( response )
		{
			_w.settings.ti.hydrateParam('gridDisputeRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'againstCompany.name'                   : 'gridDisputeFilter_Plaintive',
				'auction.stock.type.model.make.name' : 'gridDisputeFilter_Make',
				'auction.stock.type.model.name'      : 'gridDisputeFilter_Model',
				'auction.stock.type..name'           : 'gridDisputeFilter_Type',
				'auction.stock.registrationNumber'   : 'gridDisputeFilter_Reg',
				'jobState'                           : 'gridDisputeFilter_Status'
			});
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				gridData.push({
					url: 'disputeview',
					prepend: {},
					style: {
						Type   	: 'type hidden-phone hidden-tablet',
					},
					items: {
						'id'        : row.id,
						'Plaintive' : row.againstCompany.name,
						'Make'      : row.auction.stock.type.model.make.name,
						'Model'     : row.auction.stock.type.model.name,
						'Type'      : row.auction.stock.type.name,
						'Reg'       : row.auction.stock.registrationNumber,
						'Status'    : row.jobState
				}
				});
			}
			_w.settings.ti.hydrateParam('gridDisputeRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'DisputePager';
			response.Data.Meta.bind = _w.settings.pageDisputeGrid;
			_w.settings.ti.hydrateParam('gridDisputePager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});

			true == App.permissions.settingsDispute ? $('#DisputesGrid').show() : $('#DisputesGrid').hide();
			true == App.permissions.settingsClub ? $('#clubsGrid').show() : $('#clubsGrid').hide();
		},
    
    loadDisputeGridDef : function( contract, data, options )
		{
			App.API.execTask(
					'gridDisputeDef', data, options,
					_w.settings._onDisputeGridDefDataReceived, _w.taskExecError
					);
		},

		pageDisputeGridDef : function( page )
		{
			_w.settings.loadDisputeGridDef( {}, {"Grid":{"Page":page}} );
		},

		clearDisputeGridDefContext : function()
		{
			$('.gridDisputeDefContext').val('');
			$('.gridDisputeDefFilter').val('');
			_w.settings.searchDisputeGridDef();
		},

		searchDisputeGridDef : function()
		{
			var filter = {
					count: 0,
					filters: {}
			};

			filter = _w.filterIfnotEmpty(filter, 'gridDisputeDefFilter_Plaintive', 'fromCompany.name');
			filter = _w.filterIfnotEmpty(filter, 'gridDisputeDefFilter_Make', 'make.name');
			filter = _w.filterIfnotEmpty(filter, 'gridDisputeDefFilter_Model', 'model.name');
			filter = _w.filterIfnotEmpty(filter, 'gridDisputeDefFilter_Type', 'type.name');
			filter = _w.filterIfnotEmpty(filter, 'gridDisputeDefFilter_Reg', 'stock.registrationNumber');
			filter = _w.filterIfnotEmpty(filter, 'gridDisputeDefFilter_Status', 'dispute.jobState');
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			_w.settings.loadDisputeGridDef( null, request, {} );
		},

		_onDisputeGridDefDataReceived : function( response )
		{
			_w.settings.ti.hydrateParam('gridDisputeDefRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'fromCompany.name'                   : 'gridDisputeDefFilter_Plaintive',
				'auction.stock.type.model.make.name' : 'gridDisputeDefFilter_Make',
				'auction.stock.type.model.name'      : 'gridDisputeDefFilter_Model',
				'auction.stock.type..name'           : 'gridDisputeDefFilter_Type',
				'auction.stock.registrationNumber'   : 'gridDisputeDefFilter_Reg',
				'jobState'                           : 'gridDisputeDefFilter_Status'
			});
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				gridData.push({
					url: 'disputeview',
					prepend: {},
					style: {
						Type   	: 'type hidden-phone hidden-tablet',
					},
					items: {
						'id'        : row.id,
						'Plaintive' : row.fromCompany.name,
						'Make'      : row.auction.stock.type.model.make.name,
						'Model'     : row.auction.stock.type.model.name,
						'Type'      : row.auction.stock.type.name,
						'Reg'       : row.auction.stock.registrationNumber,
						'Status'    : row.jobState
				}
				});
			}
			_w.settings.ti.hydrateParam('gridDisputeDefRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'DisputePager';
			response.Data.Meta.bind = _w.settings.pageDisputeGridDef;
			_w.settings.ti.hydrateParam('gridDisputeDefPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});

			true == App.permissions.settingsDispute ? $('#DisputesGridDef').show() : $('#DisputesGridDef').hide();
			true == App.permissions.settingsClub ? $('#clubsGrid').show() : $('#clubsGrid').hide();
		},

		publishCompanyData : function()
		{
			_w.settings.ti.hydratePartial({
				'companyName' : {
					title : 'Name',
					value : App.companyData.name
				},
				'street' : {
					title : 'Street',
					value : App.companyData.street
				},
				'cityName' : {
					title : 'Town',
					value : App.companyData.city.name
				},
				'regionName' : {
					title : 'Suburb',
					value : App.companyData.city.region ? App.companyData.city.region.name : ''
				},
				'postalCode' : {
					title : 'Code',
					value : App.companyData.postalCode
				},
				'contactOffice' : {
					title : 'Landline',
					value : App.companyData.contact
						? App.companyData.contact.office
						: ''
				},
				'contactMobile' : {
					title : 'Mobile',
					value : App.companyData.contact
						? App.companyData.contact.mobile
						: ''
				},
				'contactName' : {
					title : 'Contact name',
					value : App.companyData.contact
						? App.companyData.contact.firstName + ' '
							+ App.companyData.contact.familyName
						: ''
				}
			});
		},

		publishUserData : function()
		{
			_w.settings.ti.hydratePartial({
				'firstName' : {
					title : 'Name',
					value : App.userData.firstName
				},
				'familyName' : {
					title : 'Surname',
					value : App.userData.familyName
				},
				'email' : {
					title : 'Email',
					value : App.userData.email
				},
				'mobile' : {
					title : 'Mobile',
					value : App.userData.mobile
				},
				'permissionsName' : {
					title : 'User type',
					value : App.permissions.name
				},
				'assignedTo' : {
					title : 'Assigned to',
					value : App.userData.manager
						? App.userData.manager.firstName + ' '
							+ App.userData.manager.familyName
						: ''
				}
			});
		},

		orderRetailGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.settings.loadRetailGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		},

		orderQuestionGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.settings.loadQuestionGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		},

		orderReplyGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.settings.loadReplyGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		},

		orderUserGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.settings.loadUserGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		},

		orderMemberGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.settings.loadMemberGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		},

		orderClubGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.settings.loadClubGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		},

		orderDisputeGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.settings.loadDisputeGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		},
    
    orderDisputeGridDef : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.settings.loadDisputeGridDef( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		}

	};

})();